#!/usr/bin/env python

# Arduino's cases are:	0 - wait for rising edge with timeout 5 seconds
#						1 - wait for rising edge with timeout 10 minutes
#						2 - wait for falling edge with timeout 5 seconds
#						3 - read the start pin value

import serial
import time

class CircuitSet():

	def __init__(self,port,baud):
		
		self.arduino = serial.Serial(port,baud,timeout=.1)
		time.sleep(1)

	def Trigger(self,trig,offset):
		
		data = False
		trig = str(int(trig)+offset)
		self.arduino.write(trig.encode())
		while not self.arduino.inWaiting():
			pass
		self.arduino.flushInput()
	
	def Start(self):

		self.arduino.write('3'.encode())
		result = self.arduino.readline()
		self.arduino.flushInput()
		return result