const int startTrig = A1;                // Analog input related to the starting trigger
const int acqTrig = A0;                 // Analog input related to the acquisition trigger
const int highth = 500;                 // High threshold to detect rising edge
const int lowth = 500;                  // Low threshold to detect falling edge
const int startth = 300;                   // Threshold to detect starting LED
const unsigned long longtime = 600000;  // timeout (10 minutes)
const unsigned long shorttime = 5000;   // timeout (5 seconds)

int var = 0;             // Variable to read the command
int hacq = 0;            // Variable to detect rising edge
int lacq = 1023;         // Variable to detect falling edge
int stled = 0;
unsigned long startTime = 0;

void setup() {
  // initialize serial communications at 2000000 bps:
  Serial.begin(2000000);
  pinMode(startTrig, INPUT);
  pinMode(acqTrig, INPUT);
}

void loop() {
    while(!Serial.available()){}    // wait until a command arrives
    int var = Serial.read();
    
    switch(var){
      case '0':
        startTime = millis();
        hacq = analogRead(acqTrig);
        while((hacq < highth) && ((millis()-startTime) < shorttime)){
          hacq = analogRead(acqTrig);
        }
        Serial.print(true);
        break;
      case '1':
        startTime = millis();
        hacq = analogRead(acqTrig);
        while((hacq < highth) && ((millis()-startTime) < longtime)){
          hacq = analogRead(acqTrig);
        }
        Serial.print(true);
        break;
      case '2':
        startTime = millis();
        lacq = analogRead(acqTrig);
        while((lacq > lowth) && ((millis()-startTime) < shorttime)){
          lacq = analogRead(acqTrig);
        }
        Serial.print(true);
        break;
      case '3':
        stled = analogRead(startTrig);
        if (stled > startth){
          Serial.print(true);
        }
        else{
          Serial.print(false);
        }
        break;
      default:
        break;
      }
  }
