#!/usr/bin/env python

import datetime
import json
import os

class LOGManager():

	def __init__(self):
		
		self.log = {}
		self.export = []
		self.acq = []

	def register(self,tag):

		self.tag = tag

	def camera(self,allright):

		self.log["Cam_init"] = allright[0]
		self.log["Cam_info"] = allright[1]
		self.log["Cam_AOI"] = allright[2]
		self.log["Cam_memory"] = allright[3]
		self.log["Cam_Queue"] = allright[4]

	def folder(self,x):

		self.log["Folder"] = x

	def export(self,w):
		
		self.export.append(w)

	def parameters(self,x):			# this will be deleted once the start is perform by trigger, since there won't be parameters reading anymore

		self.log["Parameter"] = x
    
	def variables(self,width,height,bytes):
    
		self.log["width"] = width
		self.log["height"] = height
		self.log["bytes"] = bytes
    
	def acquisition(self,w):

		self.acq.append(w)

	def write(self):

		x = str(datetime.datetime.now())
		x = x.split(" ")
		date = x[0].split("-")
		hours = x[1].split(":")
		end = date[0] + date[1] + date[2] + "_" + hours[0] + hours[1]
		
		LOGdst = '/home/slm/Desktop/Acquisition/LOG/'
        
		try:
			os.mkdir(LOGdst)
		except OSError:
			print("not able to create Folder")
		else:
			print("new Display directory created")
        
		local = LOGdst + self.tag + '.txt'
		
		self.log["Export"] = self.export
		self.log["Acquisition"] = self.acq
		self.log["Starttime"] = self.tag
		self.log["Endtime"] = end
		json_log = json.dumps(self.log)
		
		try:
			g = open(local,'w+')
			g.write(json_log)
			g.close()
		except IOError:
			print("LOG error")
