import datetime
import json

class LOGManager():

	def __init__(self):
		
		self.log = {}					# dictionary to be exported, will be filled as the cycle proceed
		self.export = []
		self.acq = []

	# register the tag for identification
	def register(self,tag):

		self.start = tag

	# compile the LOG with the results of the camera operations
	def camera(self,allright):

		self.log["Cam_init"] = allright[0]
		self.log["Cam_info"] = allright[1]
		self.log["Cam_AOI"] = allright[2]
		self.log["Cam_memory"] = allright[3]
		self.log["Cam_Queue"] = allright[4]

	# compile the LOG with the result of the folder creation
	def folder(self,x):

		self.log["Folder"] = x

	# "export" is a list of acquisition number that got an error during export operations
	def export(self,w):
		
		self.export.append(w)

	# compile the LOG with the result of the parameters retrieving
	def parameters(self,x):				# this will be erased once the start is done by trigger

		self.log["Parameter"] = x

	# compile the LOG with the result of the index creation
	def index(self,x):

		self.log["Index"] = x

	# "acquisition" is a list of acquisition number that got an error during acquisition operations
	def acquisition(self,w):

		self.acq.append(w)

	# write the LOG in local memory and in the external memory
	def write(self,y):

		x = str(datetime.datetime.now())
		x = x.split(" ")
		date = x[0].split("-")
		hours = x[1].split(":")
		end = date[0] + ":" + date[1] + ":" + date[2] + "_" + hours[0] + ":" + hours[1]		# add the end of the cycle
		
		local = '/home/pi/Desktop/Storage/LOG/' + self.start + '.txt'						# path for local saving
		ext = y + "LOG.txt"																	# path for external saving
		
		self.log["Export"] = self.export
		self.log["Acquisition"] = self.acq
		self.log["Endtime"] = end
		json_log = json.dumps(self.log)
		
		try:																				# tries to access external memory
			g = open(ext,'w+')
			g.write(json_log)
			g.close()
		except IOError:
			print("LOG error")
		finally:																			# execute always
			i = open(local,'w+')
			i.write(json_log)
			i.close()