import datetime
import time
import os
import json
import threading

class ExportThread(threading.Thread):

	def __init__(self,ExportErr,Inspector,tag):
		
		threading.Thread.__init__(self)
		self.flags = []
		self.paths = []
		self.images = []
		self.ExportErr = ExportErr			# LED handler for error signaling
		self.Inspector = Inspector			# LOG handler
		self.tag = tag						# tag composed from the date and time

	# add a file to the conversion queue
	def newby(self,flag,path,image):
		
		if flag == 0:
			self.flags.append(flag)			# flag signaling the success or failure
			self.paths.append(path)			# number of image (in the main is referred to as 'w')
			self.images.append(image)		# acquisition array

	# return 1 when all the entries are converted
	def authorization(self):
		
		if len(self.flags) == 0:
			return 1
		else:
			return 0

	# stop the thread
	def stop(self):

		self.kill = 1

	# conversion routine
	def run(self):

		while (self.kill == 0):
			if len(self.flags) != 0:										# means there's a file to be converted
				path = self.tag + "Image" + str(self.paths[0]) + ".txt"		# create the file's directory
				array = self.images[0]
				export = []
				try:
					f = open(path,'w+')
				except IOError:
					self.Inspector.export(w)								# register the error of the export operation
					self.ExportErr.enable()									# signal the error with the LED
					time.sleep(2)
					self.ExportErr.pause()
				else:
					for i in range(len(array)):								# convert the array in list
						export.append(int(array[i]))
					json_expo = json.dumps({"Content":export})				# convert the list in json

				f.write(json_expo)											# save the json in txt
				f.close()

				del self.flags[0]											# remove the converted file
				del self.paths[0]
				del self.images[0]

class TimerThread(threading.Thread):

	def __init__(self, circuitmanager=None, trigpin=None):
		
		threading.Thread.__init__(self)
		self.flag1 = 0
		self.flag2 = 0
		self.flag3 = 0
		self.kill = 0
		self.timer = 0
		self.warn = 0
		self.delta = 0
		self.trigpin = trigpin
		self.Alfred = circuitmanager			# handler of the GPIO methods

	# start the measuring of the recoater time
	def monitor(self):

		self.Alfred.Trigger(self.trigpin,0)		# wait for the rising edge of the trigpin (recoater)
		armstart = time.time()					# start time
		while self.flag3 == 0:
			self.arm = time.time() - armstart	# update the time removing the offset of the starting time

	# stop the timer
	def catch(self,w,ext,tag):
		
		self.Alfred.Falling(self.trigpin)		# wait for the falling edge of the trigpin (recoater)
		self.flag3 = 1							# flag triggering the stop
		path = "/media/pi/" + ext + "/" + tag + "_Arrays/Recoater.txt"
		try:									# read the recoater's times file, update it with the measured time, save it
			i = open(ipath,'r')
			json_in = i.read()
			recoater = json.loads(json_out)
			i.close()
			j.open(path,'w+')
			recoater[w] = self.arm
			json_out = json.dumps(recoater)
			j.write(json_out)
			j.close()
		except IOError:
			print("error in measuring the recoater at " + str(w) + " acquisition")

	# enable the routine (see 'run')
	def enable(self, timer=600):

		self.flag1 = 1
		self.timer = timer		# timeout expiring time

	# exit the measuring loop
	def safe(self):

		self.flag2 = 1
		time.sleep(2)
		return self.warn

	# stop the thread
	def stop(self):

		self.kill = 1

	# measuring routine
	def run(self):

		while (self.kill == 0):										# until the 'stop' is called
			if self.flag1 == 1:										# if 'enable' is called
				self.flag1 = 0										# at the next iteration the timer will need to be enabled again
				self.flag2 = 0
				outstart = time.time()								# start time
				delta = 0
				while (delta <= self.timer and self.flag2 == 0):	# while the measured time is less than the timeout expiring time and it is not called the exit
					delta = time.time() - outstart					# update the measured time
				if delta >= (self.timer-5):							# add a tolerance to the timeout
					self.warn = 1									# warning correspondent to "expired"
				else:
					self.warn = 0									# warning correspondent to "not expired"