# Libraries
import numpy as np
import cv2
import json
import os

print()
print("START")
print()

# Counter
w = 0

dir = os.getcwd()

for filename in os.listdir(dir):

	if "Arrays" in filename:
		src = filename
		x = src.split("_")
		dst = str(x[0]) + "_" + str(x[1]) + "_Display"

# Index reading
i = open(src + "\Index.txt","r")
index = json.loads(i.read())
wmax = index["n_samples"]
height = index["height"]
width = index["width"]
bytes = index["bytes"]
missed = index["missed"]
i.close()

# Create the destination directory
curpath = os.getcwd()
captpath = curpath + "/" + dst
try:
	os.mkdir(captpath)
except OSError:
	print("no new Display directory created")
else:
	print("new Display directory created")
	
while(w < (wmax-1)):
	if w not in missed:
		# Open the file and read the JSON
		g = open(src + "\Image" + str(w) + ".txt","r")
		json_data = g.read()
		data = json.loads(json_data)
		g.close()
		list = data["Content"]
		
		# Convert the JSON into a newarray (uint8), then reshape it in a np array
		newarray = np.array(list, dtype=np.uint8)
		newframe = np.reshape(newarray,(height, width, bytes))
		
		# Save image on disk
		cv2.imwrite(dst + "\Image" + str(w) + ".jpg", newframe)
	
	# Increase counter
	w = w + 1

# PERFORM ANOTHER ACQUISITION, FOR THE COMPARISON LAYER
# Open the file and read the JSON
f = open(src + "\Image" + str(w) + ".txt","r")
json_data = f.read()
data = json.loads(json_data)
f.close()
list = data["Content"]

# Convert the JSON into a newarray (uint8), then reshape it in a np array
newarray = np.array(list, dtype=np.uint8)
newframe = np.reshape(newarray,(height, width, bytes))

# Save image on disk
cv2.imwrite(dst + "\Image" + str(w) + "_post.jpg", newframe)

print()
print("END")