from __future__ import division
import numpy as np
import matplotlib.pyplot as plt

class Holes():
	
	def __init__(self,OP):
		
		self.OP = OP
	
	def Detection(self,im,lvl,maxarea,minarea):
		
		death = []
		
		(num,segmentation,labeled) = self.OP.dark_identification(lvl, lvl, im)			# identify the objects with value below a set threshold

		areatot = 0
		num = num + 1																	# since the enumeration start with zero, it exclude the highest number

		unique,counts = np.unique(labeled,return_counts=True)							# create a dictionary associating to the number of the image its number of pixels (area)
		val = dict(zip(unique,counts))

		for key in val:																	# list the element whose area is outside the range of validity
			if val[key] >= maxarea or val[key] <= minarea:
				death.append(key)
				num = num - 1

		for value in death:																# edit the labeled image to remove the objects excluded
			labeled[labeled == value] = 0
		
		for key in val:																	# count the total area excluding the objects in the deathlist
			if key not in death:
				areatot = areatot + val[key]

		centers = self.OP.centers_identification(labeled)								# use the designed functions to find the position of each holes
		quadrants = self.OP.quadrant_identification(centers,labeled)
		
		return (num,areatot,quadrants)