# ADD QUADRANT IDENTIFICATION, ADD CONTOURING ASSIGNMENT
from __future__ import division
import numpy as np

class Incandescences():
	
	def __init__(self,OP):
		
		self.OP = OP
		
	def Detection(self,rawimage,contoured,lvl,maxarea,minarea):

		(num,segmentation,labeled) = self.OP.light_identification(lvl,lvl,rawimage)				# identify the artifacts with intensity above a certain threshold
		
		num = num + 1																			# since the enumeration start with zero, it exclude the highest number
		areatot = 0
		death = []
		
		unique,counts = np.unique(labeled,return_counts=True)									# create a dictionary associating each artifact to its pixel count
		val = dict(zip(unique,counts))
		val[0] = 0

		for key in val:																			# list the artifacts with area outside the validity range
			if val[key] >= maxarea or val[key] <= minarea:
				if key not in death:
					death.append(key)
		
		for key in death:																		# edit the labeled image to remove artifacts excluded
			labeled[labeled == key] = 0
		
		centers = self.OP.centers_identification(labeled)										# use the designed functions to find the position of each artifacts
		quadrants = self.OP.quadrant_identification(centers,labeled)
		
		for center in centers:																	# list the artifacts outside the contour of an object
			p,q = centers[center]
			if contoured[p,q] == 0:
				death.append(int(center))
		
		for key in death:																		# remove the artifacts in deathlist 
			num = num - 1
			if key in val:
				del val[key]
			if str(key) in centers:
				del quadrants[str(key)]
				del centers[str(key)]

		for key in val:																			# compute the complessive area
			areatot = areatot + val[key]
		
		return (num,areatot,quadrants)